/* unicap
 *
 * Copyright (C) 2004 Arne Caspari ( arne_caspari@users.sourceforge.net )
 *
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef __UNICAPGTK_PROPERTY_DIALOG_H__
#define __UNICAPGTK_PROPERTY_DIALOG_H__


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtkwindow.h>

#include <unicap.h>
#include <unicap_status.h>


G_BEGIN_DECLS

#define UNICAPGTK_PROPERTY_DIALOG_TYPE            (unicapgtk_property_dialog_get_type())
#define UNICAPGTK_PROPERTY_DIALOG(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), UNICAPGTK_PROPERTY_DIALOG_TYPE, UnicapgtkPropertyDialog))
#define UNICAPGTK_PROPERTY_DIALOG_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), UNICAPGTK_PROPERTY_DIALOG_TYPE, UnicapgtkPropertyDialogClass))
#define IS_UNICAPGTK_PROPERTY_DIALOG(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UNICAPGTK_PROPERTY_DIALOG_TYPE))
#define IS_UNICAPGTK_PROPERTY_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UNICAPGTK_PROPERTY_DIALOG_TYPE))


typedef struct _UnicapgtkPropertyDialog       UnicapgtkPropertyDialog;
typedef struct _UnicapgtkPropertyDialogClass  UnicapgtkPropertyDialogClass;

struct _UnicapgtkPropertyDialog
{
      GtkWindow window;
      GtkWidget *tree_view;
      GtkWidget *notebook;
      GtkSizeGroup *label_group;

      unicap_handle_t unicap_handle;
      
      GList *property_list;
      GList *update_entry;
      guint  update_timeout_id;
      gint   update_interval;
      guint  update_lock_id;
};

struct _UnicapgtkPropertyDialogClass
{
		GtkWindowClass parent_class;

		void (* unicapgtk_property_dialog) (UnicapgtkPropertyDialog *ugtk);
};

GType              unicapgtk_property_dialog_get_type        ( void );
GtkWidget*         unicapgtk_property_dialog_new             ( );
GtkWidget*         unicapgtk_property_dialog_new_by_handle   ( unicap_handle_t handle );
void               unicapgtk_property_dialog_reset           ( UnicapgtkPropertyDialog *ugtk );
void               unicapgtk_property_dialog_set_device      ( UnicapgtkPropertyDialog *ugtk, 
															   unicap_device_t *device_spec );
void               unicapgtk_property_dialog_set_handle      ( UnicapgtkPropertyDialog *ugtk, 
															   unicap_handle_t handle );

G_END_DECLS

#endif /* __UNICAPGTK_PROPERTY_DIALOG_H__ */
